﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

// new
using System.Collections.ObjectModel;
using System.Diagnostics;
using Microsoft.Win32;
using System.ComponentModel;
using System.Threading;  // saveDialog

// Item: Com, search Excel
// Microsoft Excel 14.0 Object Library
using Excel = Microsoft.Office.Interop.Excel;

namespace Excel123 {
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window {

        private ObservableCollection<ModelEmployee> empl_Items = new ObservableCollection<ModelEmployee>();

        public MainWindow() {
            InitializeComponent();
        }



        private void Window_Loaded(object sender, RoutedEventArgs e) {
            createEmployees();

            datagrid.IsReadOnly = true;
            datagrid.CanUserAddRows = false;
            datagrid.CanUserDeleteRows = false;
            datagrid.CanUserResizeColumns = true;
            datagrid.CanUserSortColumns = true;

            datagrid.ItemsSource = empl_Items;

        }

        private void createEmployees() {
            int n=4000;
            ModelEmployee empl;
            for (int i = 0; i < n; i++) {
                empl = new ModelEmployee(i + 1, "Firstname_" + i.ToString("0000"), "Lastname_" + i.ToString("0000"),
                    "Street" + i.ToString("0000"), "Zipcode_" + i.ToString("0000"),
                    "City_" + i.ToString("0000"), "Country_" + i.ToString("0000"), 12345.67m, "0123456789");
                empl.Nr = i + 1;
                empl_Items.Add(empl);
            }
        }  // createEmployees

        private BackgroundWorker worker = null;

        public delegate void RunMethod(object sender, DoWorkEventArgs e);

        // private void progressing(RunMethod  runMethod) {     // are not working
        private void progressing(int runMethodNumber) {
            progressbar.Maximum = empl_Items.Count+1; 
            worker = new BackgroundWorker();
            worker.WorkerReportsProgress = true;
            worker.ProgressChanged += worker_ProgressChanged;
            switch (runMethodNumber) {
                case 0: worker.DoWork += export2ExcelBiff;
                    break;
                case 1: worker.DoWork += Export2Excel1;
                    break;
                case 2: worker.DoWork += Export2Excel2;
                    break;
                case 3: worker.DoWork += Export2Excel3;
                    break;
                    
                default: Basis.ErrorMsg("Wrong case\r\nNumber: " + runMethodNumber, "progressing");
                    break;
            }
                // save2Access;  // die run-Methode
            worker.RunWorkerAsync();
        } // progressing

        // Wichtig, diese Methode wird nach jeder Änderung aufgerufen.
        // Die Abfrage "istEnde" dient als EndeAktion
        void worker_ProgressChanged(object sender, ProgressChangedEventArgs e) {
            progressbar.Value = e.ProgressPercentage;
            if (e.ProgressPercentage == progressbar.Maximum) {
                Basis.Message("Ready", "Export to Excel");
                progressbar.Value = 0;
            }
        }

        private void bnExport2Biff_Click(object sender, RoutedEventArgs e) {
            progressing(0);  // export2ExcelBiff
        }

        private void export2ExcelBiff(object sender, DoWorkEventArgs e) {
            SaveFileDialog saveFileDialog1 = new SaveFileDialog();
            saveFileDialog1.Filter = "Excel-Datei (*.xls)|*.xls|All files (*.*)|*.*";
            saveFileDialog1.FilterIndex = 1;// zählt von 1 !
            saveFileDialog1.DefaultExt = ".xls";
            saveFileDialog1.InitialDirectory = Environment.CurrentDirectory;
            if (saveFileDialog1.ShowDialog() == true) {
                String filename = saveFileDialog1.FileName.ToString();
                Export2EXCEL exportexcel = new Export2EXCEL(filename);
                exportexcel.openFile();
                // header
                exportexcel.Write(0, 0, "Nr");
                exportexcel.Write(1, 0, "Firstname");
                exportexcel.Write(2, 0, "Lastname");
                exportexcel.Write(3, 0, "Street");
                exportexcel.Write(4, 0, "Zipcode");
                exportexcel.Write(5, 0, "City");
                exportexcel.Write(6, 0, "Country");
                exportexcel.Write(7, 0, "Monthlysalary");
                exportexcel.Write(8, 0, "Mobile");
                worker.ReportProgress(1); Thread.Sleep(5);

                int row = 0;
                foreach (ModelEmployee empl in empl_Items) {
                    row++;
                    exportexcel.Write(0, row, row);
                    exportexcel.Write(1, row, empl.Firstname);
                    exportexcel.Write(2, row, empl.Lastname);
                    exportexcel.Write(3, row, empl.Street);
                    exportexcel.Write(4, row, empl.Zipcode);
                    exportexcel.Write(5, row, empl.City);
                    exportexcel.Write(6, row, empl.Country);
                    exportexcel.Write(7, row, empl.Monthlysalary.ToString("#0.00"));
                    exportexcel.Write(8, row, empl.Mobile);
                    worker.ReportProgress(row+1);  // Thread.Sleep(5);
                }

                exportexcel.closeFile();
                Process Prog = new Process();
                Prog.StartInfo.FileName = "excel.exe";
                Prog.StartInfo.Arguments = filename;
                Prog.Start();
            }
        }


        private void bnExport2Excel1_Click(object sender, RoutedEventArgs e) {
            progressing(1);  // Export2Excel1
        }
        private void bnExport2Excel2_Click(object sender, RoutedEventArgs e) {
            progressing(2);  // Export2Excel2
        }

        private void bnExport2Excel3_Click(object sender, RoutedEventArgs e) {
            progressing(3);  // Export2Excel3
        }

        // this variant send a string to excel every cell, its very slow
        // timespan: 91 seconds
        private void Export2Excel1(object sender, DoWorkEventArgs e) {
            Stopwatch stopWatch1 = new Stopwatch();
            stopWatch1.Start();
            var xl = new Excel.Application();
            var wb = xl.Workbooks.Add();

            xl.Cells[1, 1] = "Nr";  //Row,Column
            xl.Cells[1, 1].Select();
            xl.ActiveCell.Font.Size = 12;
            xl.ActiveCell.Font.Bold = true;

            xl.Cells[1, 2] = "Vorname";
            xl.Cells[1, 2].Select();
            xl.ActiveCell.Font.Size = 12;
            xl.ActiveCell.Font.Bold = true;

            xl.Cells[1, 3] = "Nachname";
            xl.Cells[1, 3].Select();
            xl.ActiveCell.Font.Size = 12;
            xl.ActiveCell.Font.Bold = true;

            xl.Cells[1, 4] = "Monatsgehalt";
            xl.Cells[1, 4].Select();
            xl.ActiveCell.Font.Size = 12;
            xl.ActiveCell.Font.Bold = true;

            xl.Cells[1, 5] = "Jahresgehalt";
            xl.Cells[1, 5].Select();
            xl.ActiveCell.Font.Size = 12;
            xl.ActiveCell.Font.Bold = true;

            xl.Cells[1, 6] = "Straße";
            xl.Cells[1, 6].Select();
            xl.ActiveCell.Font.Size = 12;
            xl.ActiveCell.Font.Bold = true;

            xl.Cells[1, 7] = "Straße";
            xl.Cells[1, 7].Select();
            xl.ActiveCell.Font.Size = 12;
            xl.ActiveCell.Font.Bold = true;

            xl.Cells[1, 8] = "Stadt";
            xl.Cells[1, 8].Select();
            xl.ActiveCell.Font.Size = 12;
            xl.ActiveCell.Font.Bold = true;

            xl.Cells[1, 9] = "Land";
            xl.Cells[1, 9].Select();
            xl.ActiveCell.Font.Size = 12;
            xl.ActiveCell.Font.Bold = true;

            xl.Cells[1, 10] = "Handy";
            xl.Cells[1, 11].Select();
            xl.ActiveCell.Font.Size = 12;
            xl.ActiveCell.Font.Bold = true;
            worker.ReportProgress(1); Thread.Sleep(5);


            var ws = (Microsoft.Office.Interop.Excel.Worksheet)wb.ActiveSheet;

            int row = 0;
            ws.Range["A2:B" + (empl_Items.Count + 1)].Select();
            xl.Selection.NumberFormat = "@";  // String

            foreach (ModelEmployee emp in empl_Items) {                
                    row++;
                    // Title = row + "  /  " + empl_Items.Count;
                    xl.Cells[row, 1] = (row - 1).ToString();  //Row,Column
                    xl.Cells[row, 2] = emp.Firstname;
                    xl.Cells[row, 3] = emp.Lastname;
                    xl.Cells[row, 4] = emp.Monthlysalary;
                    xl.Cells[row, 5] = emp.Yearsalary;
                    xl.Cells[row, 6] = emp.Street;
                    xl.Cells[row, 7] = emp.Zipcode;
                    xl.Cells[row, 8] = emp.City;
                    xl.Cells[row, 9] = emp.Country;
                    worker.ReportProgress(row+1); 
            }
            stopWatch1.Stop();
            TimeSpan ts = stopWatch1.Elapsed;
            Basis.Message(String.Format("{0:00}:{1:00}:{2:00}.{3:00}", ts.Hours, ts.Minutes, ts.Seconds, ts.Milliseconds / 10), "Länge der Zeit");
            xl.Visible = true;
        }

        // this variant send a string to excel every row, its faster
        // timespan: 16 seconds
        private void Export2Excel2(object sender, DoWorkEventArgs e) {
            Stopwatch stopWatch1 = new Stopwatch();
            stopWatch1.Start();
            var xl = new Excel.Application();
            var wb = xl.Workbooks.Add();

            int anzCols = ModelEmployee.CaptionItemArray.Length;
            for (int i = 0; i < anzCols; i++) {
                xl.Cells[1, i + 1] = ModelEmployee.CaptionItemArray[i]; //Row,Column
                xl.Cells[1, i + 1].Select();
                xl.ActiveCell.Font.Size = 12;
                xl.ActiveCell.Font.Bold = true;
            }
            worker.ReportProgress(1); 

            var ws = (Microsoft.Office.Interop.Excel.Worksheet)wb.ActiveSheet;

            int row = 0;
            int iIndex = 0;
            // this code set twqo columns to a string-format, if one use cells with "12.123.44"  or "12.44" 
            ws.Range["A2:B" + (empl_Items.Count + 1)].Select();
            xl.Selection.NumberFormat = "@";  // String

            //Object[] items = new Object[anzCols];
            foreach (ModelEmployee emp in empl_Items) {                
                iIndex++;
                ws.Range["A2"].Offset[row].Resize[1, anzCols].Value = emp.ItemArray;
                row++;
                worker.ReportProgress(row + 1); 
            }
            stopWatch1.Stop();
            TimeSpan ts = stopWatch1.Elapsed;
            Basis.Message(String.Format("{0:00}:{1:00}:{2:00}.{3:00}", ts.Hours, ts.Minutes, ts.Seconds, ts.Milliseconds / 10), "Länge der Zeit");
            xl.Visible = true;
        }

        // this variant send a multiple rows, a block, to excel, its VERY fast
        // timespan: 2,2 seconds
        // notebook i7, samsung-SSD 1TB, Win 7
        private void Export2Excel3(object sender, DoWorkEventArgs e) {
            Stopwatch stopWatch1 = new Stopwatch();
            stopWatch1.Start();
            var xl = new Excel.Application();
            var wb = xl.Workbooks.Add();

            int anzCols = ModelEmployee.CaptionItemArray.Length;
            for (int i = 0; i < anzCols; i++) {
                xl.Cells[1, i + 1] = ModelEmployee.CaptionItemArray[i]; //Row,Column
                xl.Cells[1, i + 1].Select();
                xl.ActiveCell.Font.Size = 12;
                xl.ActiveCell.Font.Bold = true;
            }
            worker.ReportProgress(1); 

            var ws = (Microsoft.Office.Interop.Excel.Worksheet)wb.ActiveSheet;

            int n = 0;
            int rowOffset = 0;
            int row = 0;
            int iIndex = 0;
            int MAX = 10; // how many rows content a block,  maximum ca. 30 cells
            ws.Range["A2:B" + (empl_Items.Count + 1)].Select();
            xl.Selection.NumberFormat = "@";  // String

            Object[,] items = new Object[MAX, anzCols];
            foreach (ModelEmployee emp in empl_Items) {
                iIndex++;                
                n++;
                emp.insertinItemArray(rowOffset, ref items);
                rowOffset++;
                if (n == MAX) {
                    ws.Range["A2"].Offset[row].Resize[MAX, anzCols].Value = items;
                    n = 0;
                    rowOffset = 0;
                    row += MAX;
                }
                worker.ReportProgress(row + 1); 
            }
            // are there rows left?
            if (n > 0) {
                ws.Range["A2"].Offset[row].Resize[rowOffset, anzCols].Value = items;
            }
            stopWatch1.Stop();
            TimeSpan ts = stopWatch1.Elapsed;
            Basis.Message(String.Format("{0:00}:{1:00}:{2:00}.{3:00}", ts.Hours, ts.Minutes, ts.Seconds, ts.Milliseconds / 10), "Länge der Zeit");
            xl.Visible = true;
        }



        private void Window_Closing(object sender, System.ComponentModel.CancelEventArgs e) {

        }


        private void bnEsc_Click(object sender, RoutedEventArgs e) {
            Close();
        }

        private void bnOk_Click(object sender, RoutedEventArgs e) {
            Close();
        }




    }
}
